'
' WebCoder.bas
' Code for a small "Bas2Html" dll that converts a given string with
' PB code (BAS, INC) to "syntax colored" plain Html formatted result.
'
' Html is bloated garbage - usually given code becomes 2-3 times
' larger as syntax colored Html. I have tried make it create as small
' result as possible. To change Html Header and syntax colors, etc,
' see BasToSyntaxColHtml routine.
'
' One exported function - BasToSyntaxColHtml. See "WebCdemo" sample
' for "How To" declare and use this dll. Uses byte pointer parsing and
' indexed array for compare, so should be fast enough for most needs..
'
' Public Domain by Borje Hagsten, March 2003.
'--------------------------------------------------------------------
#COMPILE DLL
#INCLUDE  "WIN32API.INC"  'Basic Win API definitions
'--------------------------------------------------------------------
GLOBAL aStart() AS LONG, aCount() AS LONG
'--------------------------------------------------------------------
DECLARE SUB LoadPBdata(dArray() AS STRING)
'--------------------------------------------------------------------
' in EXE:
'DECLARE FUNCTION BasToSyntaxColHtml LIB "WebCoder.dll" _
'          ALIAS "BasToSyntaxColHtml" (BYVAL txt AS STRING) AS STRING

'
' DLL entry/exit point..
'--------------------------------------------------------------------
FUNCTION LIBMAIN (BYVAL hInstance   AS LONG, _
                  BYVAL fwdReason   AS LONG, _
                  BYVAL lpvReserved AS LONG) AS LONG
    SELECT CASE fwdReason
        CASE %DLL_PROCESS_ATTACH : FUNCTION = 1
        CASE %DLL_PROCESS_DETACH : FUNCTION = 1
        CASE %DLL_THREAD_ATTACH  : FUNCTION = 1
        CASE %DLL_THREAD_DETACH  : FUNCTION = 1
    END SELECT
END FUNCTION

'
' Redim, load and index an array with data
'--------------------------------------------------------------------
SUB LoadPBdata(dArray() AS STRING)
  LOCAL ii AS LONG, jj AS LONG, kk AS LONG, c AS LONG
 
  c = DATACOUNT
  REDIM dArray(c - 1) AS STRING 'zero based, so -1
  REDIM aStart(26), aCount(26)   'for index
 
  FOR ii = 1 TO c               'read the data into the array
     dArray(ii - 1) = UCASE$(READ$(ii))
  NEXT
 
  ARRAY SORT dArray() 'make sure array is sorted, to enable indexing for fast search
 
  jj = 64  'Index on first character, $%&# = 0, A = 1, etc..
  FOR ii = 0 TO UBOUND(dArray)
     kk = ASC(dArray(ii))
     IF kk > jj THEN    'A - Z
        aCount(jj - 64) = MAX&(0, ii - 1) 'indexed end
        jj = kk
        aStart(kk - 64) = ii
     END IF
  NEXT
  aCount(jj - 64) = MAX&(0, ii - 1)
 
  FOR ii = 0 TO 26 're-calculate count
     IF aCount(ii) THEN aCount(ii) = MAX&(0, aCount(ii) - aStart(ii) + 1)
  NEXT
 
'PB/WIN (DLL) keywords - think at least most of them..  :-)
DATA #BLOAT, #COMPILE, #DEBUG, #DIM, #ELSE, #ELSEIF, #ENDIF, #IF, #INCLUDE, #OPTION, #REGISTER, #RESOURCE
DATA #SEGMENT, #STACK, #TOOLS, $BEL, $BS, $COMPILE, $CR, $CRLF, $DEBUG, $DIM, $DQ, $ELSE, $ELSEIF, $ENDIF
DATA $EOF, $ESC, $FF, $IF, $INCLUDE, $LF, $NUL, $OPTION, $REGISTER, $RESOURCE, $SEGMENT, $SPC, $STACK
DATA $TAB, $VT, %DEF, %FALSE, %NULL, %PB_EXE, %TRUE
DATA ABS, ACCEL, ACCEPT, ACCESS, ACODE$, ADD, ADDR, ALIAS, ALL, AND, ANY, APPEND, ARRAY, ARRAYATTR
DATA AS, ASC, ASCEND, ASCIZ, ASCIIZ, AT, ATN, ATTACH, ATTRIB, BAR, BASE, BAUD, BDECL, BEEP
DATA BIN$, BINARY, BIT, BITS%, BITS&, BITS?, BITS??, BITS???, BREAK, BUTTON, BYCMD, BYCOPY, BYREF
DATA BYTE, BYVAL, CALC, CALL, CALLBACK, CALLSTK, CALLSTK$, CALLSTKCOUNT, CASE, CATCH, CBCTL, CBCTLMSG
DATA CBHNDL, CBLPARAM, CBMSG, CBWPARAM, CBYT, CCUR, CCUX, CD, CDBL, CDECL, CDWD, CEIL, CEXT, CHDIR
DATA CHDRIVE, CHECK, CHECK3STATE, CHECKBOX, CHOOSE, CHOOSE&, CHOOSE%, CHOOSE$, CHR$, CINT, CLIENT, CLNG
DATA CLOSE, CLS, CLSID$, CODEPTR, COLLATE, COLOR, COMBOBOX, COMM, COMMAND$, CON, CONNECT, CONST, CONTROL
DATA COS, CQUD, CREATE, CSET, CSET$, CSNG, CTSFLOW, CUR, CURDIR$, CURRENCY, CURRENCYX, CUX, CVBYT, CVCUR
DATA CVCUX, CVD, CVDWD, CVE, CVI, CVL, CVQ, CVS, CVWRD, CWRD, DATA, DATACOUNT, DATE$, DECLARE, DECR, DEFAULT
DATA DEFBYT, DEFCUR, DEFCUX, DEFDBL, DEFDWD, DEFEXT, DEFINT, DEFLNG, DEFQUD, DEFSNG, DEFSTR, DEFWRD, DELETE
DATA DESCEND, DIALOG, DIM, DIR$, DISABLE, DISKFREE, DISKSIZE, DISPATCH, DLL, DLLMAIN, DO, DOEVENTS, DOUBLE
DATA DOWN, DRAW, DSRFLOW, DSRSENS, DTRFLOW, DTRLINE, DWORD, ELSE, ELSEIF, EMPTY, ENABLE, END, ENVIRON$
DATA EOF, EQV, ERASE, ERR, ERRAPI, ERRCLEAR, ERROR, ERROR$, EXE, EXIT, EXP, EXP10, EXP2, EXPLICIT, EXPORT
DATA EXT, EXTENDED, EXTRACT$, FILEATTR, FILECOPY, FILENAME$, FILESCAN, FILL, FINALLY, FIX, FLOW, FLUSH, FOCUS
DATA FONT, FOR, FORMAT$, FORMFEED, FRAC, FRAME, FREEFILE, FROM, FUNCTION, FUNCNAME$, GET, GET#, GET$
DATA GETATTR, GLOBAL, GOSUB, GOTO, GUID$, GUIDTXT$, HANDLE, HEX$, HIBYT, HIINT, HIWRD, HOST, ICASE, ICON
DATA IDN, IF, IFACE, IIF, IIF&, IIF%, IIF$, IMAGE, IMAGEX, IMGBUTTON, IMGBUTTONX, IMP, IN, INCR, INP, INOUT
DATA INPUT, INPUT#, INPUTBOX$, INSERT, INSTR, INT, INTERFACE, INTEGER, INV, ISFALSE, ISNOTHING
DATA ISOBJECT, ISTRUE, ITERATE, JOIN$, KILL, LABEL, LBOUND, LCASE$, LEFT, LEFT$, LEN, LET, LIB, LIBMAIN
DATA LINE, LISTBOX, LOBYT, LOC, LOCAL, LOCK, LOF, LOG, LOG10, LOG2, LOINT, LONG, LOOP, LOWRD, LPRINT
DATA LSET, LSET$, LTRIM$, MACRO, MACROTEMP, MAIN, MAKDWD, MAKINT, MAKLNG, MAKPTR, MAKWRD, MAT, MAX, MAX$
DATA MAX%, MAX&, MCASE$, MEMBER, MENU, MID$, MIN, MIN$, MIN%, MIN&, MKBYT$, MKCUR$, MKCUX$, MKD$
DATA MKDIR, MKDWD$, MKE$, MKI$, MKL$, MKQ$, MKS$, MKWRD$, MOD, MODAL, MODELESS, MOUSEPTR, MSGBOX
DATA NAME, NEW, NEXT, NONE, NOT, NOTHING, NOTIFY, NULL, OBJACTIVE, OBJECT, OBJPTR, OBJRESULT, OCT$, OF
DATA OFF, ON, OPEN, OPT, OPTION, OPTIONAL, OR, OUT, OUTPUT, PAGE, PARITY, PARITYCHAR, PARITYREPL, PARITYTYPE
DATA PARSE, PARSE$, PARSECOUNT, PBD, PBMAIN, PEEK, PEEK$, PIXELS, POINTER, POKE, POKE$, POPUP, PORT, POST
DATA PRESERVE, PRINT, PRINT#, PRIVATE, PROFILE, PROGID$, PTR, PUT, PUT$, QUAD, QWORD, RANDOM, RANDOMIZE, READ
DATA READ$, RECEIVE, RECORDS, RECV, REDIM, REDRAW, REGEXPR, REGISTER, REGREPL, REMAIN$, REMOVE$, REPEAT$
DATA REPLACE, RESET, RESUME, RET16, RET32, RET87, RETAIN$, RETP16, RETP32, RETPRM, RETURN, RGB, RIGHT
DATA RIGHT$, RING, RLSD, RMDIR, RND, ROTATE, ROUND, RSET, RSET$, RTRIM$, RTSFLOW, RXBUFFER, RXQUE, SCAN
DATA SCROLLBAR, SDECL, SEEK, SELECT, SEND, SERVER, SET, SETATTR, SETEOF, SGN, SHARED, SHELL
DATA SHIFT, SHOW, SIGNED, SIN, SINGLE, SIZE, SIZEOF, SLEEP, SORT, SPACE$, SPC, SQR, STATE, STATIC, STATUS
DATA STDCALL, STEP, STOP, STR$, STRDELETE$, STRING, STRING$, STRINSERT$, STRPTR, STRREVERSE$, SUB, SUSPEND
DATA SWAP, SWITCH, SWITCH&, SWITCH%, SWITCH$, TAB, TAB$, TAGARRAY, TALLY, TAN, TCP, TEXT, TEXTBOX, THEN
DATA THREAD, THREADCOUNT, THREADID, TIME$, TIMEOUT, TIMER, TO, TOGGLE, TRACE, TRIM$, TRN, TRY, TXBUFFER
DATA TXQUE, TYPE, UBOUND, UCASE, UCASE$, UCODE$, UDP, UNION, UNITS, UNLOCK, UNTIL, UP, USER, USING, USING$
DATA VAL, VARIANT, VARIANT#, VARIANT$, VARIANTVT, VARPTR, VERIFY, VERSION3, VERSION4, VERSION5
DATA WEND, WHILE, WIDTH, WIDTH#, WINMAIN, WITH, WORD, WRITE, WRITE#, XOR, XINPFLOW, XOUTFLOW, ZER
 
END SUB

'
' DLL call - Convert and return syntax colored HTML from PB code string
'--------------------------------------------------------------------
FUNCTION BasToSyntaxColHtml _
  ALIAS "BasToSyntaxColHtml" (BYVAL txt AS STRING) EXPORT AS STRING

  LOCAL ii AS LONG, Ac AS LONG, stopPos AS LONG, Result AS LONG
  LOCAL wFlag AS LONG, remFlag AS LONG, dqFlag AS LONG, isRem AS LONG
  LOCAL pLet AS BYTE PTR, pLet2 AS BYTE PTR
  LOCAL tmpWord AS STRING, outBuf AS STRING, uCaseBuf AS STRING
  LOCAL htmlPrefix AS STRING, htmlPostfix AS STRING
  LOCAL greenStr AS STRING, blueStr AS STRING, redStr AS STRING, PBFstr AS STRING
  LOCAL endBlock AS STRING, endBlue AS STRING, endGreen AS STRING

  DIM cData() AS STRING
  LoadPBdata cData()

  htmlPrefix = "<HTML>" + $CRLF + _
               "<HEAD>" + $CRLF + _
               "<META HTTP-EQUIV=""Content-Type"" CONTENT=""text/html; charset=iso-8859-1"">" + $CRLF + _
               "<META NAME=""GENERATOR"" CONTENT=""WebCoder 1.0"">" + $CRLF + _
               "<TITLE>WebCoder result</TITLE>" + $CRLF + _
               "</HEAD>" + $CRLF + $CRLF + _
               "<BODY BGCOLOR=""#FFFFFF"">" + $CRLF + _
               "<PRE>" + $CRLF

  htmlPostfix = "</PRE>" + $CRLF + "</BODY>" + $CRLF + "</HTML>" + $CRLF
  greenStr    = "<FONT COLOR=""#008000"">"
  blueStr     = "<FONT COLOR=""#0000FF"">"
  PBFStr      = "<FONT COLOR=""#C06400"">"
  redStr      = "<FONT COLOR=""#FF0000"">"
  endBlock    = "</FONT>"
  endBlue     = "</FONT2>"
  endGreen    = "</FONT3>"

  REPLACE "<" WITH "&lt;" IN txt

  txt = txt + " "            'add a space to ensure last word will be checked if nothing follows it
  OutBuf   = STRING$(MAX&(1000, 5 * LEN(txt) ), 0)  '5 times bigger mem for result should be enough
  uCaseBuf = UCASE$(txt)     'use uppercase string for compare
  pLet     = STRPTR(txt)     'pointer to global string (input)
  pLet2    = STRPTR(OutBuf)  'pointer to output buffer

  FOR ii = 1 TO LEN(txt)
     SELECT CASE @pLet            'the characters we need to inlude in a word
        CASE 65 TO 90, 97 TO 122, 35 TO 38, 48 TO 57, 63, 95
           IF wFlag = 0 AND remFlag = 0 AND dqFlag = 0 THEN
              wFlag = 1 : stopPos = ii
           END IF
 
        CASE 34 ' double quote -> "
           IF dqFlag = 0 AND remFlag = 0 THEN  'if start of string literal
              POKE$ pLet2, redStr              'poke RTF code into output string
              pLet2 = pLet2 + 22               'and move pointer forward
              dqFlag = 1 : wFlag = 0           'set flags - since now inside DQ, wordflag is off
           ELSEIF dqFlag = 1 THEN              'should be end of DQ block
              @pLet2 = @pLet                   'set value in output string
              INCR pLet2                       'move one character ahead
              POKE$ pLet2, endBlock            'poke RTF end block string into output
              pLet2 = pLet2 + 7                'and move pointer forward
              dqFlag = 3                       'end of DQ - set DQ flag
           END IF
 
        CASE 59 ' asm uncomment character -> ;
           IF remFlag = 0 AND dqFlag = 2 THEN
              POKE$ pLet2, endBlock            'poke RTF end block string into output
              pLet2 = pLet2 + 7                'and move pointer forward
              POKE$ pLet2, greenStr
              pLet2 = pLet2 + 22
              remFlag = 1 : wFlag = 0
           END IF
 
        CASE 39 ' uncomment character -> '
           IF remFlag = 0 AND dqFlag <> 1 THEN
              IF dqFlag = 2 THEN
                 POKE$ pLet2, endBlock            'poke RTF end block string into output
                 pLet2 = pLet2 + 7                'and move pointer forward
              END IF
              POKE$ pLet2, greenStr
              pLet2 = pLet2 + 22
              remFlag = 1 : wFlag = 0 : isRem = 1
           END IF
 
        CASE 33 ' asm character -> !
           IF remFlag = 0 AND dqFlag = 0 THEN
              POKE$ pLet2, redStr
              pLet2 = pLet2 + 22
              dqFlag = 2 : wFlag = 0
           END IF
 
        CASE ELSE  'word is ready
           IF @pLet = 13 THEN    'if CRLF - end of line
              IF remFlag OR dqFlag THEN  'in rem or asm
                 IF isRem = 0 THEN
                    POKE$ pLet2, endBlock
                    pLet2 = pLet2 + 7
                 ELSE
                    POKE$ pLet2, endGreen
                    pLet2 = pLet2 + 8
                 END IF
                 remFlag = 0 : wFlag = 0 : dqFlag = 0 : isRem = 0 'reset flags
              END IF
           END IF
 
           IF wFlag = 1 THEN 'if we have a word
              tmpWord = MID$(uCaseBuf, stopPos, ii - stopPos)  'Get word
 
              Ac = ASC(tmpWord)         'look at first letter
              IF Ac < 91 THEN           'if within English alphabet
                 Ac = MAX&(0, Ac - 64)  'convert for index array
                 ARRAY SCAN cData(aStart(Ac)) FOR aCount(Ac), = tmpWord, TO Result 'is it in the array?
              END IF
 
              IF Result THEN                  'if match was found, it's a PB keyword
                 pLet2 = pLet2 - LEN(tmpWord) 'set position to start of word
                 POKE$ pLet2, blueStr         'and poke RTF string for blue color into output string
                 pLet2 = pLet2 + 22           'move pointer ahead
                 POKE$ pLet2, tmpWord         'poke the word into output string
                 pLet2 = pLet2 + LEN(tmpWord) 'move pointer ahead
                 POKE$ pLet2, endBlue         'and finally poke RTF end block string into output-
                 pLet2 = pLet2 + 8            'move pointer ahead
                 Result = 0                   'and reset result
              ELSE
                 IF tmpWord = "REM" THEN  'extra for REM keyword
                    pLet2 = pLet2 - 3     'set position to start of word
                    POKE$ pLet2, greenStr
                    pLet2 = pLet2 + 22
                    POKE$ pLet2, tmpWord
                    pLet2 = pLet2 + 3
                    remFlag = 1 : isRem = 1
 
                 ELSEIF tmpWord = "#PBFORMS" THEN  'extra for #PBFORMS statement
                    pLet2 = pLet2 - 8              'set position to start of word
                    POKE$ pLet2, PBFstr
                    pLet2 = pLet2 + 22
                    POKE$ pLet2, tmpWord
                    pLet2 = pLet2 + 8
                    remFlag = 1
 
                 ELSEIF tmpWord = "ASM" THEN  'extra for ASM keyword
                    pLet2 = pLet2 - 3         'set position to start of word
                    POKE$ pLet2, RedStr
                    pLet2 = pLet2 + 22
                    POKE$ pLet2, tmpWord
                    pLet2 = pLet2 + 3
                    dqFlag = 2
                 END IF
 
              END IF
              wFlag = 0
           END IF
     END SELECT
 
     IF dqFlag <> 3 THEN       'if not handled matching double-quote
        @pLet2 = @pLet         'copy original character to output
        INCR pLet2             'and increase pos in output
     ELSE
        dqFlag = 0             'else reset DQ flag
     END IF
     INCR pLet                 'move ahead to next character
  NEXT ii

  OutBuf = EXTRACT$(OutBuf, CHR$(32, 0))      'extract result (and remove the added space)

  REPLACE endBlue + " " + blueStr WITH " " IN OutBuf    'Trim size: If keywords are next to each other,
  REPLACE endBlue WITH endBlock IN OutBuf               'replace remaining blue endblocks with proper HTML

  REPLACE endGreen + $CRLF + GreenStr WITH $CRLF IN OutBuf 'remmed out lines..
  REPLACE endGreen WITH endBlock IN OutBuf              'replace remaining green endblocks with proper HTML

  FUNCTION = htmlPrefix + OutBuf + htmlPostfix

END FUNCTION
